<template>
  <div>
    <label>Hello world</label>
    <input
      class="flex-1 appearance-none border border-transparent w-full py-2 px-4 bg-white text-gray-700 placeholder-gray-400 shadow-md rounded-lg text-base focus:outline-none focus:ring-2 focus:ring-purple-600 focus:border-transparent mb-4"
      type="text"
      :dataType="dataType"
      :value="modelValue"
      @keyup="(e) => changeInput(e)"
      ref="inputCurrencyRef"
    />
  </div>
</template>

<script setup>
import { defineProps, defineEmits, ref } from 'vue';

defineProps({
  modelValue: {
    type: String,
    require: true,
    description: 'Type of data'
  },
  dataType: {
    type: String,
    require: false,
    default: 'currency',
    validator(value) {
      return ['currency'].includes(value);
    }
  }
});

const emit = defineEmits(['update:modelValue']);
const inputCurrencyRef = ref();

const formatNumber = (n) => {
  return n.replace(/\D/g, '').replace(/\B(?=(\d{3})+(?!\d))/g, ',');
};

const changeInput = () => {
  const inputCurrency = inputCurrencyRef.value;
  var inputVal = inputCurrency.value;

  if (inputVal === '') {
    return;
  }
  if (inputVal.indexOf('.') >= 0) {
    var decimal_pos = inputVal.indexOf('.');
    var left_side = inputVal.substring(0, decimal_pos);
    var right_side = inputVal.substring(decimal_pos);
    left_side = formatNumber(left_side);
    right_side = formatNumber(right_side);
    right_side = right_side.substring(0, 2);
    inputVal = left_side + '.' + right_side;
  } else {
    inputVal = formatNumber(inputVal);
  }

  inputCurrency.value = inputVal;
  emit('update:modelValue', inputVal);
};
</script>

<style></style>
